/* 
 * CS:APP Data Lab 
 * 
 * bits.c - Source file with your solutions to the Lab.
 *          This is the file you will hand in to your instructor.
 *
 */

#include "btest.h"
#include <limits.h>

/*
 * Instructions to Students:
 *
 * STEP 1: Fill in the following struct with your identifying info.
 */
team_struct team =
{
   /* Team name: Replace with either:
      Your login ID if working as a one person team
      or, ID1+ID2 where ID1 is the login ID of the first team member
      and ID2 is the login ID of the second team member */
    "ID1+ID2", 
   /* Student name 1: Replace with the full name of first team member */
   "Ada A-son",
   /* Login ID 1: Replace with the login ID of first team member */
   "ID1",

   /* The following should only be changed if there are two team members */
   /* Student name 2: Full name of the second team member */
   "Beta B-son",
   /* Login ID 2: Login ID of the second team member */
   "ID2"
};

#if 0
/*
 * STEP 2: Read the following instructions carefully.
 */

You will provide your solution to the Data Lab by
editing the collection of functions in this source file.

CODING RULES:
 
  Replace the "return" statement in each function with one
  or more lines of C code that implements the function. Your code 
  must conform to the following style:
 
  int Funct(arg1, arg2, ...) {
      /* brief description of how your implementation works */
      int var1 = Expr1;
      ...
      int varM = ExprM;

      varJ = ExprJ;
      ...
      varN = ExprN;
      return ExprR;
  }

  Each "Expr" is an expression using ONLY the following:
  1. Integer constants 0 through 255 (0xFF), inclusive. You are
      not allowed to use big constants such as 0xFFFFFFFF.
  2. Function arguments and local variables (no global variables).
  3. Unary integer operations ! ~
  4. Binary integer operations & ^ | + << >>
    
  Some of the problems restrict the set of allowed operators even further.
  Each "Expr" may consist of multiple operators. You are not restricted to
  one operator per line.

  You are expressly forbidden to:
  1. Use any control constructs such as if, do, while, for, switch, etc.
  2. Define or use any macros.
  3. Define any additional functions in this file.
  4. Call any functions.
  5. Use any other operations, such as &&, ||, -, or ?:
  6. Use any form of casting.
 
  You may assume that your machine:
  1. Uses 2s complement, 32-bit representations of integers.
  2. Performs right shifts arithmetically.
  3. Has unpredictable behavior when shifting an integer by more
     than the word size.

EXAMPLES OF ACCEPTABLE CODING STYLE:
  /*
   * pow2plus1 - returns 2^x + 1, where 0 <= x <= 31
   */
  int pow2plus1(int x) {
     /* exploit ability of shifts to compute powers of 2 */
     return (1 << x) + 1;
  }

  /*
   * pow2plus4 - returns 2^x + 4, where 0 <= x <= 31
   */
  int pow2plus4(int x) {
     /* exploit ability of shifts to compute powers of 2 */
     int result = (1 << x);
     result += 4;
     return result;
  }


NOTES:
  1. Each function has a maximum number of operators (! ~ & ^ | + << >>)
     that you are allowed to use for your implementation of the function. 
     Note that '=' is not counted; you may use as many of these as you want
     without penalty.
  2. Use the btest test harness to check your functions for correctness.
  3. The maximum number of ops for each function is given in the
     header comment for each function.
#endif

/*
 * STEP 3: Modify the following functions according the coding rules.
 * 
 *   IMPORTANT. TO AVOID GRADING SURPRISES:
 *   1. Use the btest test harness to check that your solutions produce 
 *      the correct answers. Watch out for corner cases around Tmin and Tmax.
 */

/* 
 * minusOne - return a value of -1
 *   Example: minusOne = 0xFFFFFFFF
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 2
 *   Best ops: 1
 *   Rating: 1
 */
int minusOne(void) {
  return 2;
}

/* 
 * fitsBits - Return 1 if x can be represented as an n-bit,
 *   two's complement integer, where 1 <= n <= 32.
 *   Examples: fitsBits(5,3) = 0, fitsBits(-4,3) = 1
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 15
 *   Best ops: 6
 *   Rating: 2
 */
int fitsBits(int x, int n) {
  return 2;
}

/* 
 * isLessOrEqual - If x <= y  then return 1, else return 0 .
 *   Example: isLessOrEqual(4,5) = 1.
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 24
 *   Best ops: 10
 *   Rating: 3
 */
int isLessOrEqual(int x, int y) {
  return 2;
}

/* 
 * isLess - If x < y  then return 1, else return 0.
 *   Example: isLess(4,5) = 1.
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 24
 *   Best ops: 10
 *   Rating: 3
 */
int isLess(int x, int y) {
  return 2;
}

/* 
 * sm2tc - Convert from sign-magnitude notation to two's complement.
 *   Example: sm2tc(0x80000005) = -5.
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 15
 *   Best ops: 7
 *   Rating: 4
 */
int sm2tc(int x) {
  return 2;
}

/* 
 * bitAnd - Compute x&y using only ~ and |.
 *   Example: bitAnd(6, 5) = 4
 *   Legal ops: ~ |
 *   Max ops: 8
 *   Best ops: 4
 *   Rating: 1
 */
int bitAnd(int x, int y) {
  return 2;
}

/*
 * isZero - Return 1 if x == 0, and 0 otherwise.
 *   Examples: isZero(5) = 0, isZero(0) = 1
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 2
 *   Best ops: 1
 *   Rating: 1
 */
int isZero(int x) {
  return 2;
}

/* 
 * isEqual - Return 1 if x == y, and 0 otherwise.
 *   Examples: isEqual(5,5) = 1, isEqual(4,5) = 0
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 5
 *   Best ops: 2
 *   Rating: 2
 */
int isEqual(int x, int y) {
  return 2;
}

/* 
 * evenBits - Return a word with all even-numbered bits set to 1.
 *   Example: evenBits() = 0x55555555
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 8
 *   Best ops: 4
 *   Rating: 2
 */
int evenBits(void) {
  return 2;
}

/* 
 * bitMask - Generate a number with all bits from lowbit to highbit set to 1.
 *   Example: bitMask(5,3) = 0x38
 *   Assume 0 <= lowbit <= 31, and 0 <= highbit <= 31
 *   If lowbit > highbit, then mask should be all 0's
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 16
 *   Best ops: 5
 *   Rating: 3
 */
int bitMask(int highbit, int lowbit) {
  return 2;
}

/* 
 * reverseBytes - Reverse the bytes of x.
 *   Example: reverseBytes(0x01020304) = 0x04030201
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 25
 *   Best ops: 12
 *   Rating: 3
 */
int reverseBytes(int x) {
  return 2;
}

/* 
 * conditional - Return y if x != 0, and z otherwise.
 *   Example: conditional(2,4,5) = 4
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 16
 *   Best ops: 7
 *   Rating: 3
 */
int conditional(int x, int y, int z) {
  return 2;
}

/* 
 * reverseBits - Reverse the bits of x.
 *   Example: reverseBits(0x01020304) = 0x20a04080
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 90
 *   Best ops: 34
 *   Rating: 4
 */
int reverseBits(int x) {
  return 2;
}

/*
 * isPower2 - Return 1 if x is a power of 2, and 0 otherwise.
 *   Examples: isPower2(5) = 0, isPower2(8) = 1, isPower2(0) = 0
 *   Note that no negative number is a power of 2.
 *   Legal ops: ! ~ & ^ | + << >>
 *   Max ops: 60
 *   Best ops: 8
 *   Rating: 4
 */
int isPower2(int x) {
  return 2;
}

/* 
 * isNonZero - Check whether x is nonzero using the legal operators except !.
 *   Examples: isNonZero(3) = 1, isNonZero(0) = 0
 *   Legal ops: ~ & ^ | + << >>
 *   Max ops: 10
 *   Best ops: 5
 *   Rating: 4 
 */
int isNonZero(int x) {
  return 2;
}
